/*
   Copyright (c) 2009-2012, Jack Poulson
   All rights reserved.

   This file is part of Elemental and is under the BSD 2-Clause License, 
   which can be found in the LICENSE file in the root directory, or at 
   http://opensource.org/licenses/BSD-2-Clause
*/

namespace elem {

template<typename T,typename Int=int>
class AbstractDistMatrix;

template<typename T,Distribution ColDist=MC,Distribution RowDist=MR,
         typename Int=int>
class DistMatrix;

} // namespace elem

#include "elemental/core/dist_matrix/abstract_decl.hpp"
#include "elemental/core/dist_matrix/mc_mr_decl.hpp"
#include "elemental/core/dist_matrix/mc_star_decl.hpp"
#include "elemental/core/dist_matrix/md_star_decl.hpp"
#include "elemental/core/dist_matrix/mr_mc_decl.hpp"
#include "elemental/core/dist_matrix/mr_star_decl.hpp"
#include "elemental/core/dist_matrix/star_mc_decl.hpp"
#include "elemental/core/dist_matrix/star_md_decl.hpp"
#include "elemental/core/dist_matrix/star_mr_decl.hpp"
#include "elemental/core/dist_matrix/star_star_decl.hpp"
#include "elemental/core/dist_matrix/star_vc_decl.hpp"
#include "elemental/core/dist_matrix/star_vr_decl.hpp"
#include "elemental/core/dist_matrix/vc_star_decl.hpp"
#include "elemental/core/dist_matrix/vr_star_decl.hpp"
